#!/usr/bin/perl -w
use strict;
use Math::MatrixReal;

my ($pip,$pip1,$pip2,$pip3,$pip4,$pip5,$i,$j);
my ($ndir,$file,$line,$line2,$start,$nproc,$time,$queue,$workdir);
my(@dispat,@xdisp,@ydisp,@zdisp);
my ($br11,$br12,$br13,$br21,$br22,$br23,$br31,$br32,$br33);
die "Usage: makedisp.pl [case] \n" if ($#ARGV < 0);
$ndir = $ARGV[0];
# [start] [nproc] [time] [queue]
$start = $ARGV[1];
$nproc = $ARGV[2];
$time = $ARGV[3];
$queue = $ARGV[4];


open(DISP,"DISP");
while (<DISP>) {
($pip,$pip1,$pip2,$pip3,$pip4)=unpack("A2A4A12A12A12",$_);
push(@dispat,$pip1);
push(@xdisp,$pip2);
push(@ydisp,$pip3);
push(@zdisp,$pip4);
}
close(DISP);
open(POSCAR,"POSCAR");
$pip=<POSCAR>;
$pip=<POSCAR>;
$_=<POSCAR>;
($br11,$br21,$br31)=unpack("A20A20A20",$_);
$_=<POSCAR>;
($br12,$br22,$br32)=unpack("A20A20A20",$_);
$_=<POSCAR>;
($br13,$br23,$br33)=unpack("A20A20A20",$_);
# Note transpose
my $br = Math::MatrixReal->new_from_rows([ [$br11, $br12, $br13], [$br21, $br22, $br23], [$br31, $br32, $br33] ]);
my $brinv = $br -> inverse();
close(POSCAR);

for ($j = 0; $j < @dispat; $j++ ) {
    my $vec = Math::MatrixReal->new_from_cols([ [$xdisp[$j], $ydisp[$j], $zdisp[$j]] ]);
    $vec = $brinv * $vec;
$xdisp[$j] = $vec->element(1,1);
$ydisp[$j] = $vec->element(2,1);
$zdisp[$j] = $vec->element(3,1);
}
exit;
$workdir='/wkspace2/georg/phonon/'.$ndir;
for ($j = 0; $j < @dispat; $j++ ) {
    $file=sprintf("CASE_%02i",$j+$start);
mkdir("$file",0777);
open(OUT,">$file/$file.struct");
close(OUT);
open(JOB,">$file/${ndir}_$file.job");
print JOB << "EOF";
#!/bin/csh -f 
#PBS -l nodes=$nproc
#PBS -q $queue
#PBS -l walltime=$time:00:00
cd $workdir/$file
cp ../CASE_01/*in* .
cp ../CASE_01/CASE_01.clmsum .
cp ../CASE_01/CASE_01.klist .
cp ../CASE_01/CASE_01.kgen .
cp ../CASE_01/CASE_01.recprlist .
set a=(`ls CASE_01.*`)
foreach i (\$a)
   set newname= ($file.\$i:e)
   mv \$i \$newname
end
~/bin/machine_file.pl $file \${PBS_NODEFILE} > .machines
#set nodelist = `head -6 \$PBS_NODEFILE`
#echo \"lapw0:\"\$nodelist[1]":1" \$nodelist[2]":1" \$nodelist[3]":1" \$nodelist[4]":1" \$nodelist[5]":1" \$nodelist[6]":1"   >> .machines
#~/WIENtest/run -fc .5 -p -I -r 10
~/WIENtest/run -fc .5 -I -r 15
EOF

system("cp $ndir.in* $file;\
        cp $ndir.clmsum $file;\
        cp $ndir.klist $file;\
        cp $ndir.kgen $file
");
}
print "Remember to do a ren\n"; 




open(STRUC,"$ndir.struct");
while (<STRUC>) {
    chomp;
    $line = $_;
for ($j = 0; $j < @dispat; $j++ ) {
#for ($j = 0; $j < 1; $j++ ) {
    $file=sprintf("CASE_%02i",$j+$start);
    open(OUT,">>$file/$file.struct");
    $line2=$line;
    if($line2 =~ / X=/) {
	($pip,$pip1)=unpack("A4A4",$line2);
	$pip1=abs($pip1);
	if($pip1==$dispat[$j]) {
	    ($pip,$pip1,$pip2,$pip3,$pip4,$pip5)=unpack("A12A10A3A10A3A10",$line);
	    $pip1 +=  $xdisp[$j];
	    $pip1 ++ if($pip1 < 0) ;
	    $pip3 +=  $ydisp[$j];
	    $pip3 ++ if($pip3 < 0) ;
	    $pip5 +=  $zdisp[$j];
	    $pip5 ++ if($pip5 < 0) ;
	    $line2 = pack("A12A10A3A10A3A10",$pip,$pip1,$pip2,$pip3,$pip4,$pip5);
	}
    }
	print OUT "$line2\n";
}
}



